<template>
  <ul
    class="rating-fully d-flex"
    :class="{ 'editable justify-content-end': editable }"
  >
    <li
      v-for="(number, idx) in maxRating"
      :key="idx"
      @click="() => handlerRatingClick(number)"
    >
      <i :class="`icon-star icon-star_${starType(number)}`" />
    </li>
  </ul>
</template>

<script>
export default {
  name: 'BaseRating',
  model: {
    prop: 'rating',
    event: 'change',
  },
  /**
   * @typedef Props
   * @property {String|Number} [rating=0] Текущий рейтинг
   * @property {Boolean} [editable=false] Read-only?
   * @property {Number} [maxRating=5] Максимальный рейтинг
   * @property {String|Number} id Идентификатор рейтинга
   */
  /** @type {Props} */
  props: {
    rating: {
      type: Number,
      required: false,
      default: 0,
    },
    editable: {
      type: Boolean,
      required: false,
      default: false,
    },
    maxRating: {
      type: Number,
      required: false,
      default: 5,
    },
    id: {
      type: [String, Number],
      required: false,
      default: '',
    },
  },
  methods: {
    /**
     * @this Props
     * @param {Number} rate
     */
    handlerRatingClick(rate) {
      if (this.editable) {
        this.$emit('change', this.rating === rate ? 0 : rate)
      }
    },
    /**
     * @this Props
     * @param {String|Number} number Рейтинг конкретной звезды
     * @return {'full'|'empty'} часть CSS класса
     */
    starType(number) {
      return number <= this.rating ? 'full' : 'empty'
    },
  },
}
</script>
